SystemOrganization addCategory: #'GBT-DSL_LittleCompany'!

Object subclass: #HelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!HelloWorld class methodsFor: 'example' stamp: 'hk 3/14/2017 10:36'!
example
	GbtBizAppServer initialize. GbtSVO initialize.
	(GbtThingEditor on: self hello) openWithSpec! !

!HelloWorld class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
hello
	^GbtThing struct: 'hello' define: {
		{ #summary . 'Hello #yourName'}	.
		{ #yourName . #val: . ''}	}! !

Object subclass: #Invoices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Invoices class methodsFor: 'example' stamp: 'hk 3/14/2017 10:36'!
exampleRun
	GbtBizAppServer initialize. GbtSVO initialize.
	(self invoicesContext: '') ui title: #Invoices; open! !

!Invoices class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
invoice
	^GbtThing struct: 'Invoice' define: {
		{ #date . #date: . Date today}.
		{ #Sum . #calc: . 'sum #tprice'}.
		{ #VAT . #calc: .  '0.19 * #Sum'}.
		{ #totals . #calc: .  '#VAT + #Sum'}.
		{ #items . #listOf: . LittleCompany product}.					
	} full: { 
		{ #customer . #thing: . Rolodex contact}.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 3/14/2017 13:00'!
invoiceContext: userName 
	^GbtPlainAC struct: 'Invoice'  for: userName define: {
		{#displayAs: . 'Invoice'  } .
		{#uiSpec:icon: . #GbtItemUI . #invoices}.
	"integration with other contexts in these 2 lines:"
		{#chooseFor:from: . #customer . Rolodex rolodex: userName }.
		{#chooseFor:from: . #items . LittleCompany productsContext: userName }.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 3/14/2017 13:00'!
invoicesContext: userName  
	^GbtBigListAC struct: 'Invoices'  for: userName define: {
		{#displayAs: . 'Invoices'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #invoicing} .
		{#templates: . self invoice} .
		{#display: . #(firstName lastName company date Sum VAT totals)} .
		{#subcontext: . self invoiceContext: userName} }! !

Object subclass: #LittleCompany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!LittleCompany class methodsFor: 'example' stamp: 'hk 3/14/2017 10:36'!
exampleRun
	GbtBizAppServer initialize. GbtSVO initialize.
	self login open! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 3/14/2017 13:00'!
littleCompany: userName  
	"(self littleCompany: '' ) open" 

	^GbtPlainAC struct: 'LittleCompany'  for: userName define: {
		{#aspect:on: . LittleCompany productsContext: userName . nil  } .
		{#aspect:on: . Rolodex rolodex: userName . nil  } .
		{#aspect:on: . Invoices invoicesContext: userName . nil } .		
		{#uiSpec:icon: . #GbtMainUI . #main} }! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 3/14/2017 13:00'!
login
	^ GbtLoginAC
		struct: 'LittleCompanyLogin'
		for: ''
		define:
			{{#displayAs: . #'Little Company'}.
			{#appClass:selector: . #LittleCompany . #littleCompany:}.
			{#legalText: . 'GloConn International © 2016'}}! !

!LittleCompany class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
product
	^ GbtThing
		struct: 'Product'
		define:
			{{#summary . '#amount pc à #price € = #total € . #description'}.
			{#idNumberPolicy . #BizIdPolicy}.
			{#description . #val: . ''}.
			{#amount . #val: . ''}.
			{#price . #val: . ''}.
			{#total . #calc:tag: . '#amount * #price' . #tprice}}! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 3/14/2017 13:00'!
productContext: userName  
	^GbtPlainAC struct: 'ProductContext'  for: userName define: {
		{#displayAs: . 'Product'  } .
		{#uiSpec:icon: . #GbtItemUI . #taskOrders}}! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 3/14/2017 13:00'!
productsContext: userName  
	^GbtBigListAC struct: 'ProductsContext'  for: userName define: {
		{#displayAs: . 'Products'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #taskOrders} .
		{#templates: . self product} .
		{#loadPolicy: . #simpleload } .
		{#display: . #( price amount total description)} .
		{#noPolicyPrefix: . 'Prod'}.
		{#subcontext: . self productContext: userName} }! !

Object subclass: #Rolodex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Rolodex class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
address
	^GbtThing struct: 'Address' define: { 
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityName . #val: . ''}.	
		{ #cityCode . #val: . ''}} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
contact
	^GbtThing struct: 'Contact' define: {
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #company . #val: . ''}.					
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } .
	} full: { 
		{ #address .  #thing: . self address}.
	}! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 3/14/2017 13:00'!
contactContext: userName  
	self labelDeclarative .
	^GbtPlainAC struct: 'ContactContext'  for: userName define: {
		{#displayAs: . 'Contacts'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
		{#menu: . #'print label' }.
		{#behavior:actions: . #'print label' . #(COMPOSE LabelDeclarative FREEZE thing TOPDF #(etikett pdfSlots) )}}! !

!Rolodex class methodsFor: 'example' stamp: 'hk 3/14/2017 10:36'!
exampleRun
	GbtBizAppServer initialize. GbtSVO initialize.
	(self rolodex: '') ui title: #Rolodex; open! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
labelDeclarative
	^GbtDeclarative struct: 'LabelDeclarative' define: { 
		{ #pdfSlots . #decl: . self pdfSlots }.
		{ #firstName }.		
		{ #lastName }.
		{ #address }} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 3/14/2017 13:01'!
labelSticker
	^GbtThing struct: 'Label' define: { "use calc to concatenate text"
		{ #nameLine . #calc: . ' '' #firstName '', '' '', '' #lastName '''}.		
		{ #streetLine . #calc: . ' '' #streetNo '', '' '', '' #street '' '}.
		{ #cityLine . #calc: . ' '' #cityCode '','' '', '' #cityName ''' }} ! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
pdfSlots
	^GbtDeclarative struct: 'pdfSlots' define: { 
		{ #nameLine }.		
		{ #streetLine }.
		{ #cityLine }} ! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 3/14/2017 13:00'!
rolodex: userName  
	^GbtBigListAC struct: 'Rolodex'  for: userName define: {
		{#displayAs: . 'Rolodex'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self contact} .
		{#loadPolicy: . #autoload } .
		{#display: . #(firstName lastName company cityName)} .
		{#subcontext: . self contactContext: userName}.
		{#poolThings: . {self labelSticker} }}! !
